package de.intevation.flys.client.client.ui.map;

import com.smartgwt.client.widgets.Label;
import com.smartgwt.client.widgets.layout.HLayout;

import org.gwtopenmaps.openlayers.client.LonLat;
import org.gwtopenmaps.openlayers.client.Map;
import org.gwtopenmaps.openlayers.client.MapWidget;
import org.gwtopenmaps.openlayers.client.Pixel;
import org.gwtopenmaps.openlayers.client.event.EventHandler;
import org.gwtopenmaps.openlayers.client.event.EventObject;
import org.gwtopenmaps.openlayers.client.util.JSObject;

/**
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public class MapPositionPanel extends HLayout {

    protected MapWidget mapWidget;
    protected final Map map;

    protected Label  x;
    protected Label  y;


    public MapPositionPanel(MapWidget mapWidget) {
        this.mapWidget = mapWidget;
        this.map       = mapWidget.getMap();

        this.x  = new Label();
        this.y  = new Label();
        Label d = new Label("|");

        setWidth(60);
        setMembersMargin(2);

        x.setWidth(25);
        y.setWidth(25);
        d.setWidth(5);

        addMember(x);
        addMember(d);
        addMember(y);

        // TODO This is not an optimal way to get the mouse position but makes
        // the wrapper canvas superfluous.
       this.map.getEvents().register("mousemove", map, new EventHandler() {

            @Override
            public void onHandle(EventObject eventObject) {
                JSObject xy = eventObject.getJSObject().getProperty("xy");
                Pixel px = Pixel.narrowToPixel(xy);
                LonLat lonlat = map.getLonLatFromPixel(px);

                setX(lonlat.lon());
                setY(lonlat.lat());
            }
        });
    }


    protected void setX(double x) {
        this.x.setContents(String.valueOf(x));
    }


    protected void setY(double y) {
        this.y.setContents(String.valueOf(y));
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
